#!/bin/sh

srcdir=$1
destdir=$2



AE_HEADER_DIRS="book modules"
sprefix=`( cd ${srcdir} ; pwd )`
dprefix=`( cd ${destdir} ; pwd )`

#echo "Sourcedir: ${sprefix} Destdir: ${destdir}"


rm -Rf ${dprefix}/aqfinance 2>/dev/null

# aqfinance
mkdir -p ${dprefix}/aqfinance

# link files from src/lib
hfiles=`( cd "${srcdir}/src/lib" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/${f}" "${dprefix}/aqfinance/${f}"
       ;;
  esac
done


# engine
mkdir -p ${dprefix}/aqfinance/engine

# link files from engine
hfiles=`( cd "${srcdir}/src/lib/engine" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/engine/${f}" "${dprefix}/aqfinance/engine/${f}"
       ;;
  esac
done


# link files from engine/lib
hfiles=`( cd "${srcdir}/src/lib/engine/lib" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/engine/lib/${f}" "${dprefix}/aqfinance/engine/${f}"
       ;;
  esac
done

# link files from below engine/lib
for d in ${AE_HEADER_DIRS}; do
  mkdir aqfinance/engine/${d}
  hfiles=`( cd "${srcdir}/src/lib/engine/lib/${d}" && ls *.h 2>/dev/null )`
  for f in ${hfiles}; do
    case ${f} in
      *_l.h | *_p.h)
      	 ;;
      *)
    	 ln -s "${sprefix}/src/lib/engine/lib/${d}/${f}" "${dprefix}/aqfinance/engine/${d}/${f}"
         ;;
    esac
  done
done


# report
mkdir -p ${dprefix}/aqfinance/report

# link files from report
hfiles=`( cd "${srcdir}/src/lib/engine/lib/modules/report" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/engine/lib/modules/report/${f}" "${dprefix}/aqfinance/report/${f}"
       ;;
  esac
done


# link files from report modules
hdirs=`( cd "${srcdir}/src/lib/engine/plugins/report" && ls 2>/dev/null )`
for d in ${hdirs}; do
  if test -d "${srcdir}/src/lib/engine/plugins/report/${d}"; then
    hfiles=`( cd "${srcdir}/src/lib/engine/plugins/report/${d}" && ls *.h 2>/dev/null )`
    for f in ${hfiles}; do
      case ${f} in
        *_l.h | *_p.h)
           ;;
        *)
           ln -s "${sprefix}/src/lib/engine/plugins/report/${d}/${f}" "${dprefix}/aqfinance/report/${f}"
           ;;
      esac
    done
  fi
done


# print
mkdir -p ${dprefix}/aqfinance/print

# link files from print
hfiles=`( cd "${srcdir}/src/lib/print" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/print/${f}" "${dprefix}/aqfinance/print/${f}"
       ;;
  esac
done



# update
mkdir -p ${dprefix}/aqfinance/update

# link files from update
hfiles=`( cd "${srcdir}/src/lib/update" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/update/${f}" "${dprefix}/aqfinance/update/${f}"
       ;;
  esac
done



# graphics
mkdir -p ${dprefix}/aqfinance/graphics

# link files from graphics
hfiles=`( cd "${srcdir}/src/lib/graphics" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/graphics/${f}" "${dprefix}/aqfinance/graphics/${f}"
       ;;
  esac
done



# graphs
mkdir -p ${dprefix}/aqfinance/graphs

# link files from graphs
hfiles=`( cd "${srcdir}/src/lib/graphs" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/graphs/${f}" "${dprefix}/aqfinance/graphs/${f}"
       ;;
  esac
done


# report2
mkdir -p ${dprefix}/aqfinance/report2

# link files from report2
hfiles=`( cd "${srcdir}/src/lib/report2" && ls *.h 2>/dev/null )`
for f in ${hfiles}; do
  case ${f} in
    *_l.h | *_p.h)
       ;;
    *)
       ln -s "${sprefix}/src/lib/report2/${f}" "${dprefix}/aqfinance/report2/${f}"
       ;;
  esac
done



