/***************************************************************************
 begin       : Tue May 03 2005
 copyright   : (C) 2018 by Martin Preuss
 email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef AQB_TOOL_GLOBALS_H
#define AQB_TOOL_GLOBALS_H

#include <aqfinance/engine/book/ae_book.h>

#include <aqbanking/banking.h>

#include <gwenhywfar/args.h>
#include <gwenhywfar/buffer.h>
#include <gwenhywfar/db.h>
#include <gwenhywfar/debug.h>
#include <gwenhywfar/i18n.h>
#include <gwenhywfar/cgui.h>

#define I18N(msg) GWEN_I18N_Translate(PACKAGE, msg)
#define I18S(msg) msg


#define UPDATE_URL1 "http://update1.aqbanking.de"



int readContext(const char *ctxFile,
                AB_IMEXPORTER_CONTEXT **pCtx,
                int mustExist);
int writeContext(const char *ctxFile, const AB_IMEXPORTER_CONTEXT *ctx);

int AFM_open_book_ro(AB_BANKING *ab, const char *url, AE_BOOK **pBook);
int AFM_open_book(AB_BANKING *ab, const char *url, AE_BOOK **pBook);
int AFM_create_book(AB_BANKING *ab, const char *url);


static int exportStm(AE_BOOK_TABLE_TYPE tt,
                     AB_BANKING *ab,
                     GWEN_DB_NODE *dbArgs,
                     int argc,
                     char **argv);


static int dbInit(AB_BANKING *ab,
                  GWEN_DB_NODE *dbArgs,
                  int argc,
                  char **argv);

static int dbListTrans(AB_BANKING *ab,
                       GWEN_DB_NODE *dbArgs,
                       int argc,
                       char **argv);

static int dbListTransfers(AB_BANKING *ab,
                           GWEN_DB_NODE *dbArgs,
                           int argc,
                           char **argv);

static int dbImport(AB_BANKING *ab,
                    GWEN_DB_NODE *dbArgs,
                    int argc,
                    char **argv);

static int toXml(AB_BANKING *ab,
                 GWEN_DB_NODE *dbArgs,
                 int argc,
                 char **argv);

static int dbRecon(AB_BANKING *ab,
                   GWEN_DB_NODE *dbArgs,
                   int argc,
                   char **argv);

static int dbHtmlSplitReport(AB_BANKING *ab,
                             GWEN_DB_NODE *dbArgs,
                             int argc,
                             char **argv);

static int graphReport(AB_BANKING *ab,
                       GWEN_DB_NODE *dbArgs,
                       int argc,
                       char **argv);

static int graphReport2(AB_BANKING *ab,
                        GWEN_DB_NODE *dbArgs,
                        int argc,
                        char **argv);

static int update(AB_BANKING *ab,
                  GWEN_DB_NODE *dbArgs,
                  int argc,
                  char **argv);


#endif




