/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_EDITSTATEMENTS_HPP
#define FF_EDITSTATEMENTS_HPP


#include "ff_statementtable.hpp"

#include <aqfinance/engine/book/ae_statement.h>

#include <fx.h>

#include <list>



class FF_App;
class FOX16_HtmlLabel;



class FF_EditStatements: public FXDialogBox {
  FXDECLARE(FF_EditStatements)
public:

  enum {
    ID_STATEMENT_LIST=FXDialogBox::ID_LAST,
    ID_FILTER_BY_PURPOSE,
    ID_FILTER_BY_ACCOUNT,
    ID_FILTER_BY_NAME,
    ID_FILTER_BY_IBAN,
    ID_AUTOMATCH,
    ID_LAST
  };

  FF_EditStatements(FF_App* a,
		    FXComposite *parent,
		    const FXString& title,
		    FXuint opts=DECOR_TITLE|DECOR_BORDER,
		    FXint x=0, FXint y=0, FXint w=0, FXint h=0,
		    FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
		    FXint hs=0, FXint vs=0);
  ~FF_EditStatements();

  static bool editStatements(FF_App* app,
			     FXComposite *parent,
			     const FXString &title,
			     AE_STATEMENT_LIST *tlist);

  void init();
  void fini();

  FXint checkGui(FXbool quiet);
  void toGui(const AE_STATEMENT_LIST *tlist);
  void fromGui(AE_STATEMENT_LIST *tlist);

  void autoMatch();

  void create();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdFilterByPurpose(FXObject*, FXSelector, void *ptr);
  long onCmdFilterByAccount(FXObject*, FXSelector, void *ptr);
  long onCmdFilterByName(FXObject*, FXSelector, void *ptr);
  long onCmdFilterByIban(FXObject*, FXSelector, void *ptr);

  long onCmdAutoMatch(FXObject*, FXSelector, void *ptr);

  long onListRightBtnReleased(FXObject*, FXSelector, void *ptr);

  long onTableContentReplaced(FXObject*, FXSelector, void* ptr);


protected:
  FF_EditStatements();

  FF_App *m_app;

  FOX16_HtmlLabel *m_label;
  FF_StatementTable *m_statementTable;
};


#endif


