/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2009 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_FILTERACTION_HPP
#define FF_FILTERACTION_HPP


#include <fx.h>

#include <list>

#include <aqfinance/engine/book/ae_statement.h>



class FF_App;


class FF_FilterAction {
public:
  FF_FilterAction(FF_App *a, int id, const FXString &label);
  virtual ~FF_FilterAction();

  int getId() const { return m_id;};

  const FXString &getLabel() const { return m_label;};

  virtual int init();
  virtual void fini();

  virtual FXComposite *createSettingsWindow(FXComposite *parentForWidget);
  virtual void releaseSettingsWindow(FXComposite *w);

  virtual int toGui(FXComposite *w, GWEN_DB_NODE *db);
  virtual int fromGui(FXComposite *w, GWEN_DB_NODE *db);
  virtual int checkGui(FXComposite *w);

  virtual void enter(FXComposite *w);
  virtual void leave(FXComposite *w);

  virtual int execute(AE_STATEMENT *st);

protected:
  FF_App *m_app;
  int m_id;
  FXString m_label;
};


typedef std::list<FF_FilterAction*> FF_FilterActionPtrList;


#endif

