/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FM_INVOICEPAGE_HPP
#define FM_INVOICEPAGE_HPP


#include "ff_invoicetree.hpp"

#include <aqfinance/engine/book/ae_book.h>

#include <gwenhywfar/db.h>

#include <fx.h>

#include <list>


class FF_InvoiceTree;
class FM_BusinessPage;


class FM_InvoicePage: public FXHorizontalFrame {
  FXDECLARE(FM_InvoicePage)

public:
  enum {
    ID_INVOICE_TREE=FXPacker::ID_LAST,
    ID_BUTTON_NEW_INVOICE,
    ID_BUTTON_ADD_PAYMENT,

    ID_LAST
  };

public:
  FM_InvoicePage(bool isIncoming,
		 FM_BusinessPage *mainPage,
		 FXComposite *p,
		 FXuint opts=0,
		 FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FM_InvoicePage();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void dbOpened(AE_BOOK *bk);
  void dbClosing();
  void dbClosed();
  void dbReload(AE_BOOK_TABLE_TYPE tt);

  void enter();
  void leave();
  void reset();

  long onCmdNewInvoice(FXObject*, FXSelector, void*);
  long onCmdAddPayment(FXObject*, FXSelector, void*);

  long onTreeChanged(FXObject*, FXSelector, void*);
  long onTreeRightBtnPress(FXObject*, FXSelector, void*);

  void dump(int indent);

protected:
  FM_InvoicePage();

  void rebuild();

  bool m_isIncoming;
  FM_BusinessPage *m_mainPage;

  FF_InvoiceTree *m_invoiceTree;

  FXButton *m_newInvoiceButton;
  FXButton *m_addPaymentButton;

  bool m_needRebuild;
  bool m_isVisible;
};




#endif

