/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_BANKACCOUNTLIST_HPP
#define FF_BANKACCOUNTLIST_HPP


#include <fx.h>

#include <aqfinance/engine/book/ae_bankaccount.h>

#include <list>




class FF_BankAccountList: public FXList {

public:
  enum {
    COPYMODE_NONE=0,
    COPYMODE_COPY,
    COPYMODE_ATTACH
  };

public:
  FF_BankAccountList(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
                     FXint x=0, FXint y=0, FXint w=0, FXint h=0);

  virtual ~FF_BankAccountList();

  void addBankAccount(AE_BANKACCOUNT *ba);
  void addBankAccounts(AE_BANKACCOUNT_LIST2 *bl, int copyMode);

  void removeBankAccount(AQDB_ID id);

  AE_BANKACCOUNT *getCurrentBankAccount();
  AE_BANKACCOUNT *getFirstSelectedBankAccount();
  void getSelectedBankAccounts(AE_BANKACCOUNT_LIST2 *bl, int copyMode);

  void selectBankAccount(AQDB_ID id);
  void deselectBankAccount(AQDB_ID id);

protected:
  FF_BankAccountList();

};



#endif


