/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2011 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/



#ifndef AE_MODULES_HHD_P_H
#define AE_MODULES_HHD_P_H


#include "ae_hhd.h"


static int AE_HHD14_ReadBytesDec(const char *p, int len);
static int AE_HHD14_ReadBytesHex(const char *p, int len);
static unsigned int AE_HHD14_Quersumme(unsigned int i);
static int AE_HHD14_CalcLuhnSum(const char *code, int len);
static int AE_HHD14_CalcXorSum(const char *code, int len);

static int AE_HHD14_ExtractDataForLuhnSum(const char *code, GWEN_BUFFER *xbuf);
static void AE_HHD14_CompressCode(const uint8_t *code, GWEN_BUFFER *cbuf);
static void AE_HHD14_ExtractCode(GWEN_BUFFER *cbuf);

static int AE_HHD14__Translate(const char *code, GWEN_BUFFER *cbuf);



#endif
